<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>YouTube Video Bookmark</title>

    <!-- Boostrap CSS -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css">

    <style>
        @import url('https://fonts.googleapis.com/css2?family=Poppins:wght@500&display=swap');

        * {
            margin: 0;
            padding: 0;
            font-family: 'Poppins', sans-serif;
        }

        body {
            background: linear-gradient(to bottom, rgba(200,200,200,0.15) 0%, rgba(0,0,0,0.15) 100%), radial-gradient(at top center, rgba(200,200,200,0.40) 0%, rgba(0,0,0,0.40) 120%) #989898;
            background-blend-mode: multiply,multiply;
            height: 100vh;
        }

        .main {
            display: flex;
            flex-direction: column;
            justify-content: center;
            align-items: center;
        }

        .main > h1 {
            font-size: 60px;
            margin: 50px;
            text-shadow: 4px 4px 2px rgba(0,0,0,0.6);
            color: rgb(255, 255, 255);
        }

        .search-container {
            display: flex;
            flex-direction: column;
            justify-content: center;
            align-items: center;
        }

        .search-container > h2 {
            color: rgb(255, 255, 255);
            text-shadow: 4px 4px 2px rgba(0,0,0,0.6);
            margin: 15px;
        }

        .group {
            display: flex;
            line-height: 30px;
            align-items: center;
            position: relative;
            width: 550px;
            box-shadow: rgba(0, 0, 0, 0.24) 0px 3px 8px;
        }

        .input {
            width: 100%;
            line-height: 28px;
            padding: 0.4rem 1rem;
            padding-left: 2.5rem;
            font-size: 17px;
            border: 2px solid transparent;
            border-radius: 8px;
            outline: none;
            background-color: #f3f3f4;
            color: #0d0c22;
            transition: 0.3s ease;
        }

        .input::placeholder {
            color: #9e9ea7;
        }

        .input:focus,
        input:hover {
        outline: none;
            border-color: rgba(234, 226, 183, 0.4);
            background-color: #fff;
            box-shadow: 0 0 0 4px rgb(234 226 183 / 10%);
        }

        .icon {
            position: absolute;
            left: 1rem;
            fill: #9e9ea7;
            width: 1rem;
            height: 1rem;
        }

        .preview-container {
            background-color: rgb(240, 240, 240);
            width: 1000px;
            padding: 20px;
            margin: 15px;
            border-radius: 10px;
            box-shadow: rgba(0, 0, 0, 0.24) 0px 3px 8px;
            display: flex;
            flex-direction: column;
        }
        
        .preview {
            display: flex;
            flex-wrap: wrap;
            justify-content: center;
            align-items: center;
        }

        .preview > img {
            height: 170px;
        }

        .bookmarks-container {
            display: flex;
            flex-direction: column;
            width: 85%;
            height: 450px;
            overflow: auto;
            margin-top: 50px;
            background-color: rgb(200, 200, 200);
            padding: 20px;
            border-radius: 10px;
        }

        .bookmarks-container > h2 {
            color: rgb(90, 90, 90);
            text-shadow: 4px 4px 2px rgba(255,255,255,0.6);
        }
        
        .bookmarks {
            display: flex;
            flex-wrap: wrap;
        }

        .bookmark {
            background-color: rgb(255, 255, 255);
            box-shadow: rgba(0, 0, 0, 0.24) 0px 3px 8px;
            padding: 15px;
            border-radius: 10px;
            margin: 20px;
            width: 400px;
        }

        .bookmark iframe {
            border: none;
        }

        .actions a,.actions button {
            font-size: 12px;
        }
    </style>
</head>
<body>
    
    <div class="main">
        <h1>YouTube Video Bookmark</h1>
        <div class="search-container">
            <h2>Paste your YouTube link here:</h2>
            <div class="group">
                <svg viewBox="0 0 24 24" aria-hidden="true" class="icon">
                    <g>
                    <path
                        d="M21.53 20.47l-3.66-3.66C19.195 15.24 20 13.214 20 11c0-4.97-4.03-9-9-9s-9 4.03-9 9 4.03 9 9 9c2.215 0 4.24-.804 5.808-2.13l3.66 3.66c.147.146.34.22.53.22s.385-.073.53-.22c.295-.293.295-.767.002-1.06zM3.5 11c0-4.135 3.365-7.5 7.5-7.5s7.5 3.365 7.5 7.5-3.365 7.5-7.5 7.5-7.5-3.365-7.5-7.5z"
                    ></path>
                    </g>
                </svg>
                <input class="input" type="search" placeholder="Search" oninput="previewYouTubeVideo(this.value)"/>
            </div>

        </div>
    
        <div class="preview-container" style="display:none">
            <h5>YouTube Video Preview:</h5>
            <div class="preview row pr-2 pl-2">
                <img class="col-md-4" id="youtubeThumbnail" alt="Video Thumbnail" />
                <form class="col-md-8" action="./endpoint/add-bookmark.php" method="POST">
                    <input type="hidden" class="form-control" id="youtubeEmbedUrl" name="embed_url" readonly>

                    <div class="form-group">
                        <label for="youtubeTitle">YoutTube Title:</label>
                        <input type="text" class="form-control" id="youtubeTitle" name="youtube_title" readonly>
                    </div>
                    <div class="form-group">
                        <label for="youtubeLink">YouTube Link:</label>
                        <input type="text" class="form-control" id="youtubeLink" name="youtube_link" readonly>
                    </div>
                    <div class="action-button float-right">
                        <button type="button" class="btn btn-danger">Cancel</button>
                        <button type="submit" class="btn btn-dark">Save Bookmark</button>
                    </div>
                    
                </form>

                <div class="titles col-md-9">
                    <h5 id="video-title"></h5>
                    <p id="video-link"></p>
                </div>
            </div>

            <div class="video-not-found text-center" style="display: none;">
                <h1 class="mb-3">Video Not Found</h1>
                <button type="button" class="btn btn-dark" onclick="location.reload()">Back to Home Page.</button>
            </div>
        </div>

        <div class="bookmarks-container">
            <h2>Bookmarked Video:</h2>
            
            <div class="bookmarks">

                <?php 
                    include ('./conn/conn.php');

                    $stmt = $conn->prepare("SELECT * FROM tbl_bookmark");
                    $stmt->execute();

                    $result = $stmt->fetchAll();

                    foreach ($result as $row) {
                        $bookmarkID = $row['tbl_bookmark_id'];
                        $youtubeTitle = $row['youtube_title'];
                        $youtubeLink = $row['youtube_link'];
                        $embedURL = $row['embed_url'];
                    ?>

                    <div class="bookmark">
                        <iframe width="370" height="200" src="<?= $embedURL ?>" allowfullscreen></iframe>
                        <h6><?= $youtubeTitle ?></h6>
                        <div class="actions float-right">
                            <button type="button" class="btn btn-danger" onclick="deleteBookmark(<?= $bookmarkID ?>)">Delete Bookmark</button>
                            <a type="button" class="btn btn-primary" href="<?= $youtubeLink ?>" target="_blank">Go to Link</a>
                        </div>
                    </div>

                    <?php 
                    }    
                ?>

            </div>

        </div>

    </div>

    <script>
        async function previewYouTubeVideo(url) {
            // Extract video ID from the YouTube URL
            const videoIdMatch = url.match(/[?&]v=([^&]+)/);
            const videoId = videoIdMatch ? videoIdMatch[1] : null;

            document.querySelector('.preview-container').style.display = '';
            document.querySelector('.bookmarks-container').style.display = 'none';

            if (videoId) {
                // Fetch video information using the YouTube Data API
                const apiKey = 'AIzaSyAJpnegxVs8WUMff_kOYeWkJ_a6roMmyas';
                const apiUrl = `https://www.googleapis.com/youtube/v3/videos?id=${videoId}&key=${apiKey}&part=snippet`;
                const embedUrl = convertYouTubeUrl(url);

                try {
                    const response = await fetch(apiUrl);
                    const data = await response.json();

                    // Display video information in the preview container
                    const previewContainer = document.querySelector('.preview');
                    const titleElement = document.getElementById('youtubeTitle');
                    const thumbnailElement = document.getElementById('youtubeThumbnail');
                    const linkElement = document.getElementById('youtubeLink');

                    if (data.items && data.items.length > 0) {
                        const video = data.items[0].snippet;

                        titleElement.value = video.title;
                        thumbnailElement.src = video.thumbnails.medium.url;
                        linkElement.value = `https://www.youtube.com/watch?v=${videoId}`;
                        document.getElementById('youtubeEmbedUrl').value = embedUrl;

                        previewContainer.style.display = '';
                    } else {
                        // Handle error or show a message if the video information is not available
                        titleElement.textContent = 'Video not found';
                        thumbnailElement.src = '';
                        linkElement.textContent = '';
                        
                        previewContainer.style.display = 'none';
                    }
                } catch (error) {
                    console.error('Error fetching video information:', error);
                }
            } else {
                document.querySelector('.preview').style.display = 'none';
                document.querySelector('.video-not-found').style.display = '';
            }
        }
        
        function convertYouTubeUrl(url) {
            // Use a regular expression to extract the video ID from the URL
            var match = url.match(/(?:https?:\/\/)?(?:www\.)?(?:youtube\.com\/(?:[^\/\n\s]+\/\S+\/|(?:v|e(?:mbed)?)\/|\S*?[?&]v=)|youtu\.be\/)([a-zA-Z0-9_-]{11})/);

            // If a match is found, construct the embed URL
            if (match && match[1]) {
                var videoId = match[1];
                var embedUrl = "https://www.youtube.com/embed/" + videoId;
                return embedUrl;
            } else {
                // If no match is found, return an empty string
                return "";
            }
        }


        function deleteBookmark(id) {
            if (confirm('Do you want to delete this bookmark?')) {
                window.location.href = "./endpoint/delete-bookmark.php?bookmark=" + id;
            }
        }

    </script>
</body>
</html>